#!/usr/bin/ruby

require 'json'
require 'socket'
require 'date'

processes = {}

$host = Socket.gethostname

$time = Time.now.to_i

$output = []

if ! File.exists?('/var/tmp/software_data_finished.json')
  exit 0
end

File.rename("/var/tmp/software_data_finished.json", "/var/tmp/software_data_finished.json.#{$time}")

jobs = JSON.parse(File.read("/var/tmp/software_data_finished.json.#{$time}"))

exit 0 if jobs['processes'] == nil

time_used = {}

jobs['processes'].each do |k, v| 
  if v['time'].to_i > 0 and v['cputime'].to_i > 0
     if v['job'] != nil 
        job = v['job'][0]
     end
     if job != nil
       p = v['exe_path']
       if p =~ /afs\/ics.muni.cz\/software/
         if p =~ /afs\/ics.muni.cz\/software\/ncbr\/softrepo/
           mod = p.sub(/.*afs\/ics.muni.cz\/software\/ncbr\/softrepo\/[^\/]*\//, '')
           mod = mod.sub(/^([^\/]*\/[^\/]*).*/, '\1')
         else
           if p =~ /.*?-.*\/.*?-/
             p = p.sub(/(.*-.*\/.*)-.*/, '\1')
           end
           mod = p.sub(/.*\/ics.muni.cz\/software\//, '')
           if mod =~ /(.*[-\/]\d+.\d+[^\/]*).*/
             mod = mod.sub(/(.*[-\/]\d+.\d+[^\/]*).*/, '\1')
           else
             mod = mod.sub(/^([^\/]*).*/, '\1')
           end
         end
         mod = mod.split(/\//)
         if mod[-2] == nil
            mod = mod[-1]
         else
            mod = "#{mod[-2]}-#{mod[-1]}"
         end
       end
       time = v['end_time']*1000
       while time_used[time] != nil
        time += 1
       end
       time_used[time] = 1
       storage = 0
       scratch = 0
       v['open_files'].each do |f|
         if f =~ /^\/scratch/
             scratch = 1
         end
         if f =~ /\/storage-/ 
             storage = 1
         end
       end
       $output << { 'name' => 'jobsaccount', 'user' => v['user'], 'walltime' => v['time'], 
                    'path'=>v['exe_path'], 'cmd' => v['command'], 'bin' => v['exe_path'].sub(/.*\//, ''), 
                    'swap' => v['vm_swap_bytes'], 'mem_rss' => v['vm_rss_bytes'],
                    'cputime' => v['cputime'].to_i, 'scratch' => scratch, 'storage' => storage,
                    'host' => $host, 'time' => time, 'wid' => nil, 'job' => job, 'module' => mod }
     end
  end
end

puts JSON.pretty_generate($output)
